<?php

class Mykassa
{
    private $event;

    public function __construct(MykassaEvent $event)
    {
        $this->event = $event;
    }

    public function getResult()
    {
        $request = $_REQUEST;
        
        if (!empty($request['account'])
            AND !empty($request['sum'])
            AND $request['action'] == 'fk_go'
        ) return $this->GoTomykassa($request);

        if (empty($request['MERCHANT_ID'])
            || empty($request['us_account'])
            || empty($request['SIGN'])
            || empty($request['AMOUNT'])
            || empty($request['MYKASSA_ID'])
        )
        {
            return $this->getResponseError('Invalid request');
        }

        if ($request['SIGN'] != md5(Config::MERCHANT_ID.':'.$request['AMOUNT'].':'.Config::SECRET_KEY_2.':'.$request['MERCHANT_ORDER_ID']))        
        {
            return $this->getResponseError('Incorrect digital signature');
        }

        $mykassaModel = MykassaModel::getInstance();
        
        if ($mykassaModel->getPaymentByMykassaId($request['MYKASSA_ID']))
        {
            //   
            return $this->getResponseSuccess('Payment already exists');
        }
       
        $itemsCount = floor($request['AMOUNT'] / Config::ITEM_PRICE);
        if ($itemsCount <= 0)
        {
            return $this->getResponseError(' ' . $request['AMOUNT'] . ' .      ' .
                ' ' . Config::ITEM_PRICE . ' .');
        }
        if (!$mykassaModel->createPayment(
            $request['MYKASSA_ID'],
            $request['us_account'],
            $request['AMOUNT'],
            $itemsCount
        ))
        {
            return $this->getResponseError('Unable to create payment database');
        }
        
        $checkResult = $this->event->check($request);
        if ($checkResult !== true)
        {
            return $this->getResponseError($checkResult);
        }
        
        $payment = $mykassaModel->getPaymentByMykassaId($request['MYKASSA_ID']);
        
        if ($payment && $payment->status == 1)
        {
            return $this->getResponseSuccess('Payment has already been paid');
        }

        if (!$mykassaModel->confirmPaymentByMykassaId($request['MYKASSA_ID']))
        {
            return $this->getResponseError('Unable to confirm payment database');
        }

        $this->event->pay($request);

        return $this->getResponseSuccess('YES');
    }
    
    private function GoTomykassa($request)
    {
        $m = Config::MERCHANT_ID;
        $oa = $request['sum'];
        $o = ' ';
        $us_account = $request['account'];
        $s = md5(implode(':', array($m, $oa, Config::SECRET_KEY_1, $o)));

        header("Location: //www.mykassa.org/api/merchant.php?m={$m}&oa={$oa}&o={$o}&s={$s}&us_account={$us_account}");
        return;
    }

    private function getResponseSuccess($message)
    {
        return $message;
    }

    private function getResponseError($message)
    {
        return $message;
    }
}
